<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_CLASS_OPN_DEFAULT_IMAGES_INCLUDED') ) {
	define ('_OPN_CLASS_OPN_DEFAULT_IMAGES_INCLUDED', 1);

	class opn_default_images {

		/*<{4php5}>var!!private<{4php5/}>*//*<{delete}>*/ var /*<{delete/}>*/ $_defaultimages = array ();


		/**
		 * PHP 5 classconstructor
		 * 		
		 */
		function __constructor () {
			$this->_defaultimages['edit'] = 'edit.gif';
			$this->_defaultimages['delete'] = 'del.gif';
			$this->_defaultimages['info'] = 'info.gif';
			$this->_defaultimages['activate'] = 'lamp_on.gif';
			$this->_defaultimages['deactivate'] = 'lamp_off.gif';
			$this->_defaultimages['inherit'] = 'lamp_inh.gif';
			$this->_defaultimages['up'] = 'arrow/up_small.gif';
			$this->_defaultimages['down'] = 'arrow/down_small.gif';
			$this->_defaultimages['preferences'] = 'preferences.png';
			$this->_defaultimages['image'] = 'image.png';
			$this->_defaultimages['search'] = 'search.png';
		}

		/**
		 * PHP 4 classconstructor
		 * 		
		 */
		function opn_default_images () {

			$this->__constructor ();
		}

		/**
		 * Generates the image searchlink
		 * @param $url
		 * @param $class	optional
		 * @param $title	optional
		 * @param $text		optional
		 * @param $new		optional
		 * @return string
		 */
		function get_search_link ($url, $class = '', $title = '', $text = '', $new = false) {

			if ($title == '') {
				$title = _SEARCH;
			}
			return $this->_build_image_link ($url, $this->_defaultimages['search'], $class, $title, $text, $new);

		}

		/**
		 * Builds the search image tag
		 * 		
		 * @param $title
		 * @return string
		 */
		function get_search_image ($title) {

			return $this->_build_image($this->_defaultimages['search'], $title);

		}


		/**
		 * Generates the image editlink
		 * @param $url
		 * @param $class	optional
		 * @param $title	optional
		 * @param $text		optional
		 * @param $new		optional
		 * @return string
		 */
		function get_edit_link ($url, $class = '', $title = '', $text = '', $new = false) {

			if ($title == '') {
				$title = _EDIT;
			}
			return $this->_build_image_link ($url, $this->_defaultimages['edit'], $class, $title, $text, $new);

		}

		/**
		 * Builds the edit image tag
		 * 		
		 * @param $title
		 * @return string
		 */
		function get_edit_image ($title) {

			return $this->_build_image($this->_defaultimages['edit'], $title);

		}

		/**
		 * Generates the image viewlink
		 * @param $url
		 * @param $class	optional
		 * @param $title	optional
		 * @param $text		optional
		 * @param $new		optional
		 * @return string
		 */
		function get_view_link ($url, $class = '', $title = '', $text = '', $new = false) {

			if ($title == '') {
				$title = _VIEW_DETAIL;
			}
			return $this->_build_image_link ($url, $this->_defaultimages['info'], $class, $title, $text, $new);

		}


		/**
		 * Builds the info image tag
		 * 		
		 * @param $title
		 * @return string
		 */
		function get_view_image ($title) {

			return $this->_build_image($this->_defaultimages['info'], $title);

		}

		/**
		 * Generates the image deletelink
		 * 
		 * @param $url
		 * @param $class	optional
		 * @param $title	optional
		 * @param $text		optional
		 * @param $new		optional
		 * @param $new		optional
		 * @return string
		 */
		function get_delete_link ($url, $class = '', $title = '', $text = '', $new = false) {

			if ($title == '') {
				$title = _DELETE;
			}
			return $this->_build_image_link ($url, $this->_defaultimages['delete'], $class, $title, $text, $new);

		}

		/**
		 * Builds the delete image tag
		 * 		
		 * @param $title
		 * @return string
		 */
		function get_delete_image ($title) {

			return $this->_build_image($this->_defaultimages['delete'], $title);

		}

		/**
		 * Generates the image preferenceslink
		 * 
		 * @param $url
		 * @param $class	optional
		 * @param $title	optional
		 * @param $text		optional
		 * @param $new		optional
		 * @return string
		 */
		function get_preferences_link ($url, $class = '', $title = '', $text = '', $new = false) {

			if ($title == '') {
				$title = _PREFERENCES;
			}
			return $this->_build_image_link ($url, $this->_defaultimages['preferences'], $class, $title, $text, $new);

		}

		/**
		 * Builds the preferences image tag
		 * 		
		 * @param $title
		 * @return string
		 */
		function get_preferences_image ($title) {

			return $this->_build_image($this->_defaultimages['preferences'], $title);

		}

		/**
		 * Generates the image uplink
		 * 
		 * @param $url
		 * @param $class	optional
		 * @param $title	optional
		 * @param $text		optional
		 * @param $new		optional
		 * @return string
		 */
		function get_up_link ($url, $class = '', $title = '', $text = '', $new = false) {

			if ($title == '') {
				$title = _UP;
			}
			return $this->_build_image_link ($url, $this->_defaultimages['up'], $class, $title, $text, $new);

		}

		/**
		 * Builds the up image tag
		 * 		
		 * @param $title
		 * @return string
		 */
		function get_up_image ($title) {

			return $this->_build_image($this->_defaultimages['up'], $title);

		}

		/**
		 * Generates the image downlink
		 * 
		 * @param $url
		 * @param $class	optional
		 * @param $title	optional
		 * @param $text		optional
		 * @param $new		optional
		 * @return string
		 */
		function get_down_link ($url, $class = '', $title = '', $text = '', $new = false) {

			if ($title == '') {
				$title = _DOWN;
			}
			return $this->_build_image_link ($url, $this->_defaultimages['down'], $class, $title, $text, $new);

		}

		/**
		 * Builds the down image tag
		 * 		
		 * @param $title
		 * @return string
		 */
		function get_down_image ($title) {

			return $this->_build_image($this->_defaultimages['down'], $title);

		}

		/**
		 * Generates the image imagelink
		 * 
		 * @param $url
		 * @param $class	optional
		 * @param $title
		 * @param $text		optional
		 * @param $new		optional
		 * @return string
		 */
		function get_image_link ($url, $class = '', $title, $text = '', $new = false) {

			return $this->_build_image_link ($url, $this->_defaultimages['image'], $class, $title, $text, $new);

		}

		/**
		 * Builds the image image tag
		 * 		
		 * @param $title
		 * @return string
		 */
		function get_image_image ($title) {

			return $this->_build_image($this->_defaultimages['image'], $title);

		}

		/**
		 * Generates the image lamp on or off link
		 * 		
		 * @param $url
		 * @param $activate
		 * @param $class			optional
		 * @param $titleactivate	optional
		 * @param $titledeactivate	optional
		 * @param $text				optional
		 * @param $new				optional
		 * @return string
		 */
		function get_activate_deactivate_link ($url, $activate, $class = '', $titleactivate = '', $titledeactivate = '', $text = '', $new = false) {

			if ($activate) {
				return $this->get_activate_link($url, $class, $titleactivate, $text, $new);
			}
			return $this->get_deactivate_link($url, $class, $titledeactivate, $text, $new);
		}

		/**
		 * Builds the lamp on or lamp off image tag
		 * 		
		 * @param $activate
		 * @param $titleactivate
		 * @param $titledeactivate
		 * @return string
		 */
		function get_activate_deactivate_image ($activate, $titleactivate, $titledeactivate) {

			if ($activate) {
				return $this->get_activate_image ($titleactivate);
			}
			return $this->get_deactivate_image ($titledeactivate);

		}

		/**
		 * Generates the image lamp on link
		 * @param $url
		 * @param $class	optional
		 * @param $title	optional
		 * @param $text		optional
		 * @param $new		optional
		 * @return string
		 */
		function get_activate_link ($url, $class = '', $title = '', $text = '', $new = false) {

			if ($title == '') {
				$title = _DEACTIVATE;
			}
			return $this->_build_image_link ($url, $this->_defaultimages['activate'], $class, $title, $text, $new);

		}

		/**
		 * Builds the lamp on image tag
		 * 		
		 * @param $title
		 * @return string
		 */
		function get_activate_image ($title) {

			return $this->_build_image($this->_defaultimages['activate'], $title);

		}

		/**
		 * Generates the image lamp off link
		 * @param $url
		 * @param $class	optional
		 * @param $title	optional
		 * @param $text		optional
		 * @param $new		optional
		 * @return string
		 */
		function get_deactivate_link ($url, $class = '', $title = '', $text = '', $new = false) {

			if ($title == '') {
				$title = _ACTIVATE;
			}
			return $this->_build_image_link ($url, $this->_defaultimages['deactivate'], $class, $title, $text, $new);

		}

		/**
		 * Builds the lamp off image tag
		 * 		
		 * @param $title
		 * @return string
		 */
		function get_deactivate_image ($title) {

			return $this->_build_image($this->_defaultimages['deactivate'], $title);

		}

		/**
		 * Generates the lamp on, lamp off or lamp inherit image link
		 * 		
		 * @param $url
		 * @param $activate
		 * @param $class	optional
		 * @param $title	optional
		 * @param $text		optional
		 * @param $new		optional
		 * @return string
		 */
		function get_inherit_link ($url, $activate, $class = '', $title = '', $text = '', $new = false) {

			if ($activate == 0) {
				return $this->get_deactivate_link($url, $class, $title, $textm, $new);
			}
			if ($activate == 1) {
				return $this->get_activate_link($url, $class, $title, $text, $new);
			}
			return $this->_get_inherit_link($url, $class, $title, $text, $new);
		}

		/**
		 * Build the lamp inherit image tag
		 * 		
		 * @param $title
		 * @return string
		 */
		function get_inherit_image ($title) {

			return $this->_build_image ($this->_defaultimages['inherit'], $title);

		}

		// private functions

		/**
		 * Generates the image link
		 * 
		 * @param $url
		 * @param $image
		 * @param $class
		 * @param $title
		 * @param $text
		 * @param $new
		 * @return string
		 */
		function _build_image_link ($url, $image, $class, $title, $text, $new) {

			global $opnConfig;

			if ($class == '') {
				$class = '%alternate%';
			}
			$help = '';
			if ($new) {
				$help = ' target="_blank"';
			}
			$image = $opnConfig['opn_default_images'] . $image;
			if ($class == '*') {
				$hlp = '<a href="' . encodeurl ($url ) . '" title="' . $title .'"' . $help .'><img src="' . $image .'" class="imgtag" alt="' .  $title . '" title="' .  $title . '" />';
			} else {
				$hlp = '<a class="' . $class .'" href="' . encodeurl ($url ) . '" title="' . $title .'"' . $help .'><img src="' . $image .'" class="imgtag" alt="' .  $title . '" title="' .  $title . '" />';
			}
			if ($text != '') {
				$hlp .= $text;
			}
			$hlp .= '</a>';
			return $hlp;
		}

		/**
		 * Generates the imagetag
		 * 		
		 * @param $image
		 * @param $title
		 * @return string
		 */
		function _build_image ($image, $title) {

			global $opnConfig;

			$image = $opnConfig['opn_default_images'] . $image;
			$hlp = '<img src="' . $image .'" class="imgtag" alt="' .  $title . '" title="' .  $title . '" />';
			return $hlp;
		}

		/**
		 * Generates the image lamp inherit link
		 * @param $url
		 * @param $class	optional
		 * @param $title	optional
		 * @param $text		optional
		 * @param $new		optional
		 * @return string
		 */
		function _get_inherit_link ($url, $class = '', $title = '', $text = '', $new = false) {

			if ($title == '*') {
				$title = '';
			} elseif ($title == '') {
				$title = _DEACTIVATE;
			}
			return $this->_build_image_link ($url, $this->_defaultimages['inherit'], $class, $title, $text, $new);

		}


	}
}
?>